/*
 *
 *     This file is part of the Squashtest platform.
 *     Copyright (C) 2017 Henix, henix.fr
 *
 *     See the NOTICE file distributed with this work for additional
 *     information regarding copyright ownership.
 *
 *     This is free software: you can redistribute it and/or modify
 *     it under the terms of the GNU Lesser General Public License as published by
 *     the Free Software Foundation, either version 3 of the License, or
 *     (at your option) any later version.
 *
 *     this software is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU Lesser General Public License for more details.
 *
 *     You should have received a copy of the GNU Lesser General Public License
 *     along with this software.  If not, see <http://www.gnu.org/licenses/>.
 */
package org.squashtest.tm.plugin.rest.validators;

import org.springframework.stereotype.Component;
import org.springframework.validation.BeanPropertyBindingResult;
import org.springframework.validation.BindException;
import org.springframework.validation.BindingResult;
import org.springframework.validation.Errors;
import org.springframework.validation.Validator;
import org.squashtest.tm.plugin.rest.controller.helper.ErrorHandlerHelper;
import org.squashtest.tm.plugin.rest.jackson.model.CheckingAttributeTestStepDtoVisitor;
import org.squashtest.tm.plugin.rest.jackson.model.TestStepDto;
import org.squashtest.tm.plugin.rest.jackson.model.TestStepDtoVisitor;
import org.squashtest.tm.plugin.rest.validators.helper.TestStepValidationHelper;

import javax.inject.Inject;
import java.util.ArrayList;
import java.util.List;

import static org.squashtest.tm.plugin.rest.jackson.model.RestType.REQUIREMENT;
import static org.squashtest.tm.plugin.rest.jackson.model.RestType.TEST_STEP;

/**
 * Created by jthebault on 16/06/2017.
 */
@Component
public class TestStepPostValidator implements Validator {

    @Inject
    private TestStepValidationHelper testStepValidationHelper;

    @Override
    public boolean supports(Class<?> clazz) {
        return TestStepDto.class.isAssignableFrom(clazz);
    }

    @Override
    public void validate(Object target, final Errors errors) {
        TestStepDto testStepDto = (TestStepDto) target;

        if (testStepDto.getId() != null) {
            errors.rejectValue("id", "generated value", "This attribute is generated by database and should not be provided. If you want to update an existing test step, please do a patch request to the test step id. ");
        }

        TestStepDtoVisitor visitor = new CheckingAttributeTestStepDtoVisitor(testStepValidationHelper, errors);

        try {
            testStepDto.accept(visitor);
        } catch (BindException e) {
            e.printStackTrace();
        }
    }

    public void validateRequirements(long testStepId, List<Long> requirementIds, String errorMessage) throws BindException {
        List<Errors> errors = new ArrayList<>();

        new TestStepDto() {
            @Override
            public void accept(TestStepDtoVisitor testStepDtoVisitor) throws BindException {

                validateRequirementsChecker(testStepDtoVisitor, errors, errorMessage, testStepId, requirementIds);


            }
        };
    }

    private void validateRequirementsChecker(Object obj,
                                             List<Errors> errors,
                                             String errorMessage,
                                             Long testStepId,
                                             List<Long> requirementIds)throws BindException {

        BindingResult validationBean = new BeanPropertyBindingResult(obj, errorMessage);
        testStepValidationHelper.checkEntityExist(validationBean, TEST_STEP, testStepId);
        for (Long id : requirementIds) {
            testStepValidationHelper.checkEntityExist(validationBean, REQUIREMENT, id);
        }
        if (validationBean.hasErrors()) {
            errors.add(validationBean);
        }
        ErrorHandlerHelper.throwIfError(obj, errors, errorMessage);


    }

}
